{Egy Pascal record a bootsector felptshez hasonlan:}

type

   PBootSecInforms = ^TBootSecInforms;
   TBootSecInforms = record
     JMP            : Array[1..3] of Byte;
     OEMName        : Array[1..8] of Char;
     Byte_Sector    : Word;
     Sector_Cluster : Byte;
     ReservedSecs   : Word;
     FATCount       : Byte;    {FATCount * SectorInOneFAT          }
     MaxRootEntries,           {(MaxRootEntries * 32) / Byte_Sector}
     Total_Sector   : Word;    {DataStart = ReservedSecs + FATSize + RootSize}
     MediaDescriptor: Byte;
     SectorInOneFAT,
     Sector_Track,
     Head_Number,
     Hidden_Sector  : Word;    {if partitions > 32M then It's the Lo Word    }
     Hidden_SectorHi: Word;    {if partitions > 32M then used else not used  }
     BIGTotal_Sector: Longint; {if (partitions > 32M) And (Total_Sector = 0) }
     PhisicalDriveNo: Byte;    {   then used else not used                   }
     InfoLevel      : Word;    {Must be 0 ???}
     SerialNumber   : Longint; {In Hex (bin) }
     VolumeLabel    : Array[1..11] of Char; {'NO NAME    ' if none present}
     FileSystemType : Array[1..8] of Char;  {'FAT12   '    or 'FAT16   '  }
   end;

BEGIN
END. 

{Ksbb e rekord hasznlatval is foglalkozunk amikor az INT 13h-at veszk !}