(* keretu.pas unit *)
unit keretu;
{ a KERETU.PAS file-ban kell megrni! }

{--------------------- interface ---------------------}
interface
   var keretszin, torolszin: byte;

   { Adott kpernyterlet keretezse }
   procedure keret(x1,y1,x2,y2,tipus,kszin:byte);

   { Adott kpernyterlet trlse }
   procedure torol(x1,y1,x2,y2,szin:byte);


{------------------- implementation--------------------}
implementation
uses crt;

function ellenor(a1,a2,b1,b2:byte):boolean;
{ A helyes terletkijells ellenrzse
  - (a1,a2) : a bal fels sarok koordinti
  - (b1,b2) : a jobb als sarok koordinti
}
var ok:boolean;
begin
  ok:=true;
  {if (a1>=b1) or (a2>=b2) then ok:=false;
  if not((a1 in [1..80]) and (a2 in [1..25])) then ok:=false;
  if (b1<1)  or (b1>80) and (b2<1) or (b2>25) then ok:=false;}
  (*Nem okoz RTE-t ezrt felesleges - Dvid*)
  ellenor:=ok;
end;

procedure torol(x1,y1,x2,y2,szin:byte);
{
  - (x1,y1) : a bal fels sarok koordinti
  - (x2,y2) : a jobb als sarok koordinti
  - szin    : a terlet szne
}
var sor:string[80];
    i:integer;
begin
  if ellenor(x1,y1,x2,y2) then
     begin
       window(x1,y1,x2,y2);
       textbackground(szin);
       clrscr;
       window(1,1,80,25);
    end;
end;

procedure keret(x1,y1,x2,y2,tipus,kszin:byte);
{
  - (x1,y1) : a bal fels sarok koordinti
  - (x2,y2) : a jobb als sarok koordinti
  - tipus   : vonaltpus (1 - egyszeres, 2 - dupla , 3 vastag)
  - kszin   : a keret szne
}
var i:byte;
    r:string[9];
begin
  if ellenor(x1,y1,x2,y2) then
     begin
       case tipus of
          1: r:=#218+#191+#192+#217+#196+#179+#196; {'ڿĳ';}
          2: r:=#201+#187+#200+#188+#205+#186+#205; {'ɻȼͺ';}
          3: r:=#219+#219+#219+#219+#223+#219+#220; {'';}
       end;
       textcolor(kszin);
       gotoxy(x1,y1); write(r[1]);
       for i:=x1 to x2-2 do  write(r[5]);
       write(r[2]);
       for i:=1 to ((y2-1)-y1) do
         begin
           gotoxy(x1,y1+i); write(r[6]);
           gotoxy(x2,y1+i); write(r[6]);
         end;
       gotoxy(x1,y2); write(r[3]);
       for i:=x1 to (x2-2) do  write(r[7]);
       write(r[4]);
     end;
end;

{---------------------- unit init -----------------------}
begin
  keretszin:=15; { feher }
  torolszin:=0 ; { fekete }
  textbackground(torolszin);
  clrscr;
  textcolor(keretszin);
end.

