unit matrix;
interface
	function KeyPressed:boolean;
   var
      ktb:array[0..127] of boolean;
   function ReadKey:char;
implementation
	uses dos;
{----------------------------------------------------------------------------}
{                  billentyzetmtrixot fogunk hasznlni                     }
{----------------------------------------------------------------------------}
	procedure KeyIRQ;                                               assembler;
	asm
	  push    DS
	  push    ax
	  push    bx
	  push    cx
	  mov     ax,Seg Ktb
	  mov     DS,ax
	  xor     bh,bh
	  mov     cl,bh

	  in      al,60h

	  mov     bl,al
	  and     bl,7fh
	  shl     al,1
	  cmc
	  adc     cl,00
	  mov     [bx+Offset Ktb],cl

	  in      al,61h
	  mov     ah,al
	  or      al,80h
	  out     61h,al
	  mov     al,ah
	  out     61h,al

	  mov     al,20h
	  out     20h,al

	  pop     cx
	  pop     bx
	  pop     ax
	  pop     DS
	  iret
	end;
{----------------------------------------------------------------------------}
{                        A KeyPressed tdefinilsa                          }
{----------------------------------------------------------------------------}
function KeyPressed:boolean;
	var
   	i:byte;
begin
	keyPressed:=false;
	for i:=0 to 127 do
   begin
      if ktb[i] then
      begin
      	KeyPressed:=true;
         exit;
      end;
   end;
end;
{----------------------------------------------------------------------------}
{                          A ReadKey tdefinilsa                           }
{----------------------------------------------------------------------------}
function ReadKey:char;
	var
   	c:char;
begin
   if ktb[30] then c:='a';
   if ktb[48] then c:='b';
   if ktb[46] then c:='c';
   if ktb[32] then c:='d';
   if ktb[18] then c:='e';
   if ktb[33] then c:='f';
   if ktb[34] then c:='g';
   if ktb[35] then c:='h';
   if ktb[23] then c:='i';
   if ktb[36] then c:='j';
   if ktb[37] then c:='k';
   if ktb[38] then c:='l';
   if ktb[50] then c:='m';
   if ktb[49] then c:='n';
   if ktb[24] then c:='o';
   if ktb[25] then c:='p';
   if ktb[16] then c:='q';
   if ktb[19] then c:='r';
   if ktb[31] then c:='s';
   if ktb[20] then c:='t';
   if ktb[22] then c:='u';
   if ktb[47] then c:='v';
   if ktb[17] then c:='w';
   if ktb[45] then c:='x';
   if ktb[30] then c:='y';
   if ktb[42] then c:=UpCase(c);
   ReadKey:=c;
end;
{---------------------------------------------------------------------------}
{                           Mtrix inicializlsa                           }
{---------------------------------------------------------------------------}
begin
	SetIntVec($09,@KeyIRQ);
end.
