unit pcspeak;
interface
	type
	  	hangrec=record
	     	Hz:word;
	      time:word;
	   end;
   	PCM=array[1..100] of hangrec;
   procedure LoadSound(s:string;var hangok:pcm);
   procedure PlaySound(hangok:pcm);
implementation
	uses crt;
	var
   	f:file of PCM;
	procedure LoadSound;
   begin
		FillChar(hangok,SizeOf(hangok),#0);
      Assign(f,s);
      Reset(f);
      Read(f,hangok);
      Close(f);
   end;
   procedure PlaySound;
   	var
         i:byte;
   begin
            for i:=1 to 100 do
            begin
               if hangok[i].hz>18 then Sound(hangok[i].Hz) else NoSound;
               Delay(hangok[i].time);
            end;
            NoSound;
   end;
end.