unit perspect;
interface
   procedure SetAlapTav(tav:word);
   procedure PerspectPont(x,y,z,color:integer);
   procedure PerspectLine(x1,y1,z1,x2,y2,z2:real);
   procedure PerspectRecTangle(x1,y1,x2,y2,z2:integer);
   procedure SetIranyPontok(ux,uy:word);
   function Convert(x,z:real):integer;
   procedure perspectCircle(x,y,z,radius:real);
   procedure barvertical(x1,y1,z1,x2,y2,z2:real);
	var
      alaptav:word;
      ix,iy:word;
implementation
	uses graph;
   function Round(x:real):longint;
   begin
      if x>maxlongint then round:=maxlongint
      else
      if x<-maxlongint-1 then round:=-maxlongint-1
      else
      	Round:=system.Round(x);

   end;
	procedure SetAlapTav;
   begin
   	alaptav:=tav;
   end;
   procedure PerspectPont;
   begin
      PutPixel(ix+Round(x*(alaptav/z)),iy+Round(y*(alaptav/z)),color);
   end;
   procedure PerspectLine;
   begin
      if (z2>0) and (z1>0) and (x1*(alaptav/z1)<maxlongint)
      	and (x2*(alaptav/z2)<maxlongint)
      	and (y1*(alaptav/z1)<maxlongint)
      	and (y2*(alaptav/z2)<maxlongint)
		 then
      Line(ix+Round(x1*(alaptav/z1)),iy+Round(y1*(alaptav/z1)),
      	ix+Round(x2*(alaptav/z2)),iy+Round(y2*(alaptav/z2)));
	end;
   procedure PerspectCircle;
   begin
      if (z>0) then
      Circle(ix+Round(x*(Alaptav/z)),iy+Round(y*(alaptav/z)),
      	round(radius*(alaptav/z)));
	end;
   procedure PerspectRecTangle;
   begin
      if z2>0 then
      RecTangle(ix+Round(x1*(alaptav/z2)),iy+Round(y1*(alaptav/z2)),
      	ix+Round(x2*(alaptav/z2)),iy+Round(y2*(alaptav/z2)));
	end;
   procedure SetIranypontok;
   begin
   	ix:=ux;
      iy:=uy;
   end;
   function Convert;
   begin
      if z<=0 then if x>0 then Convert:=32767 else Convert:=-32768
      else
	      Convert:=round(alaptav/z*x);
   end;
   procedure BarVertical;
   begin
      PerspectLine(x1,y1,z1,x2,y1,z2);
      PerspectLine(x2,y1,z2,x2,y2,z2);
      PerspectLine(x2,y2,z2,x1,y2,z1);
      PerspectLine(x1,y2,z1,x1,y1,z1);
      if (z2+z1)/2>0 then
         FloodFill((Convert(x1,z1)+Convert(x2,z2)) div 2,
			(Convert(y1,z1)+Convert(y2,z2)) div 2,GetColor);
   end;
begin
	alaptav:=640;
   ix:=320;
   iy:=240;
end.