(* hunexit.pas *)

{ A program tetszleges pontjn trtn kilps
  a unitban megadott hun_exit eljrson keresztl
  megy vgbe. Vigyzat a hiba cimnek helyessge nem garantlt!
}

unit hunexit;
 {$F+,O+}
interface

{ res! }

implementation

const
     maxhiba=44;

type hibarec= record
       kod : byte;
       szoveg : string;
end;

const
  hibak : array [1..maxhiba+1] of hibarec =(
   (kod:001; szoveg:'Nem ltez DOS-fggvny hvsa.'),
   (kod:002; szoveg:'A fjl, amelyre hivatkoztunk, nem ltezik.'),
   (kod:003; szoveg:'Az adott elrsi tvonal vagy az adott knyvtr nem ltezik.'),
   (kod:004; szoveg:'A megengedettnl tbb a megnyitott fjl.'),
   (kod:005; szoveg:'A fjlhoz nem tudunk hozzfrni.'),
   (kod:006; szoveg:'rvnytelen fjler (fjlazonost).'),
   (kod:012; szoveg:'rvnytelen fjlhozzfrsi kd.'),
   (kod:015; szoveg:'A GetDir s a Chdir eljrsok paramtereknt hibs egysgszmot adtunk meg.'),
   (kod:016; szoveg:'Az RmDir eljrs nem tudja trlni az adott knyvtrat.'),
   (kod:017; szoveg:'A Rename eljrs nem tudja tnevezni az adott fjlt.'),
   (kod:018; szoveg:'A FindFirst vagy a FindNext eljrs nem tall a megadott nvnek s attribtumoknak megfelel fjl.'),
   (kod:100; szoveg:'A hibakddal a Read eljrs jelez, ha tpusos fjl nem ltez rszt kvnjuk beolvasni.'),
   (kod:101; szoveg:'A hiba azt jelzi, hogy a fjlmveletek sorn a lemez megtelt.'),
   (kod:102; szoveg:'Nem hasznltuk az Assign eljrst a Reset, a Rewrite, az Append, az Erase s a Rename eljrsok eltt.'),
   (kod:103; szoveg:'Az llomny nincs megnyitva - fjlmvelet vgzse a fjl megnyitsa eltt.'),
   (kod:104; szoveg:'A llomnyt nem olvassra nyitottuk meg.'),
   (kod:105; szoveg:'A llomnyt nem rsra nyitottuk meg. '),
   (kod:106; szoveg:'rvnytelen numerikus adatformtum .'),
   (kod:150; szoveg:'A lemez rsvdett.'),
   (kod:151; szoveg:'Ismeretlen egysg.'),
   (kod:152; szoveg:'A meghajt zemkptelen.'),
   (kod:153; szoveg:'Ismeretlen utasts.'),
   (kod:154; szoveg:'Adathiba (CRC-hiba).'),
   (kod:155; szoveg:'Helytelen hosszsg az adatkrsi adatstruktra.'),
   (kod:156; szoveg:'Lemez-pozicinlsi hiba.'),
   (kod:157; szoveg:'Ismeretlen tpus adathordoz.'),
   (kod:158; szoveg:'Az adott szektor nem tallhat.'),
   (kod:159; szoveg:'A papr elfogyott a nyomtatbl.'),
   (kod:160; szoveg:'Az eszkzre trtn rs sorn hiba lpett fel.'),
   (kod:161; szoveg:'Az eszkzrl trtn olvass sorn hiba lpett fel.'),
   (kod:162; szoveg:'Hibs hardver.'),
   (kod:200; szoveg:'Nullval val oszts.'),
   (kod:201; szoveg:'Index- vagy rtkhatr-tllps a {$R+} direktvval fordtott programban.'),
   (kod:202; szoveg:'Verem (stack) tlcsordulsa a {$S+} direktvval fordtott programban.'),
   (kod:203; szoveg:'A halomterlet (heap) tlcsordulsa a New vagy a GetMem hvsa sorn.'),
   (kod:204; szoveg:'A Dispose s a FreeMem eljrsok hvsakor megadott mutat nil, vagy nem a heapre mutat.'),
   (kod:205; szoveg:'Tlcsorduls a lebegpontos mveleteknl.'),
   (kod:206; szoveg:'Alulcsorduls a lebegpontos mveleteknl.'),
   (kod:207; szoveg:'Helytelen lebegpontos mvelet.'),
   (kod:208; szoveg:'Az overlaykezel teleptse nem trtnt meg az OvrInit eljrssal.'),
   (kod:209; szoveg:'Az overlay-llomny olvassa sorn hiba lpett fel.'),
   (kod:210; szoveg:'Az objektum virtulis metdusra trtn illeglis hivatkozs.'),
   (kod:211; szoveg:'Absztrakt metdus hvsa.'),
   (kod:215; szoveg:'Tlcsorcsorduls egsz adatokkal vgzett mveletek sorn a {$Q+} direktvval fordtott programban.'),
   (kod:0;   szoveg:'Vge!'));

const
      hexdigit : array[0..15] of char = '0123456789ABCDEF';

var
      exitvec : pointer;
      i : integer;

type
   str2 = string[2];
   str4 = string[4];

{ decimlis byte  -> hexadecimlis string[2] konverzi }
function hexbyte(b:byte) : str2;
begin
    hexbyte:=hexdigit[b shr 4] + hexdigit[b mod 16];
end;

{ decimlis word  -> hexadecimlis string[4] konverzi }
function hex(w:word) : str4;
begin
    hex:=hexbyte(hi(w)) + hexbyte(lo(w));
end;

{ A sajt kilpsi eljrs }
procedure hun_exit; far;
begin
  if (exitcode<>0) or (erroraddr<>nil) then
     begin
        assign(output,'');
        rewrite(output);
        writeln(#7'Hiba trtnt a program futsa sorn!');
        if exitcode=$ff then
           writeln('A felhasznl szaktotta meg a program futst')
         else
            begin
              writeln('A hiba kdja: ', exitcode);
              write('A hibt okoz utasts cme: ');
              writeln(hex(seg(erroraddr^)),':',hex(ofs(erroraddr^)));
              for i:=1 to maxhiba+1 do
                if exitcode=hibak[i].kod then break;
              if i<>maxhiba+1 then
                writeln('A hiba oka: ', hibak[i].szoveg);
            end;
     end
   else
    writeln('Ksznjk, hogy hasznlta a programunkat!');
  ReadLn;
  erroraddr := nil;
  exitproc  := exitvec; { Norml kilps }
end;

{ A modult hasznl program inicializlsa  sorn
  vgrehajtd utastsok }
begin
  exitvec:=exitproc;
  exitproc:=@hun_exit;
end.
