(* DET.PAS *)
{$M 65000,0,0}
program determinans;

const max=8;

type
  am=array [1..max,1..max] of real;

const
  cam:am=((1,2,3,4,5,6,3,2),
          (6,4,3,1,3,0,0,7),
          (3,2,1,9,5,5,7,7),
          (5,3,9,9,9,1,2,2),
          (2,1,0,3,2,0,9,4),
          (6,9,1,8,3,6,5,3),
          (7,4,0,1,3,1,2,1),
          (1,4,6,0,1,3,4,2));


{ nem rekurzv determinnst szmt fggvny }
  function det(const m0:am; n:integer):real;
   {! az m0[1,1] elem nem lehet 0!}
   var
     i,j,k,l : integer;
     s       : real;
     m1, m2  : am;
   begin
      if m0[1,1]=0 then
                     begin
                       writeln('Sorok cserje szksges!');
                       det:=0;
                       exit;
                     end;
      m2:=m0;
      for k:=1 to n-1 do
      begin
        { m1 egysgmtrix }
        fillchar(m1, sizeof(m1), #0);
        for i:=1 to n do m1[i,i]:=1;

        for i:=k+1 to n do
          begin
             m1[i,k]:=-m2[i,k]/m2[k,k];
          end;

        for i:=1 to n do
          for j:=1 to n do
            begin
              s:=0;
              for l:=1 to n do
                s:=s+m1[i,l]*m2[l,j];
              m2[i,j]:=s;
            end;
      end;
      s:=1;
      for i:=1 to n do s:=s*m2[i,i];
      det:=s;
   end;

{ rekurzv determinnst szmt fggvny }
  function detr(var m0:am; n:integer):real;
   var
        m1 : am;
        s  : real;
        e,i,j, j0 : byte;
   begin
     if N=2
      then
        detr:=m0[1,1]*m0[2,2]-m0[1,2]*m0[2,1]
      else
        begin
           s := 0;
           { A mtrix els sorban rgztjk az elemeket }
           for e:=1 to n do
           begin
               { Az e. aldeterminns meghatrozsa }
               for i:=2 to n do
                  begin
                     j0:=1;
                     for j:=1 to n do
                         if e<>j then
                           begin
                             m1[i-1,j0]:=m0[i,j];
                             inc(j0);
                           end;
                  end;
                s:=s+(ord(odd(e))-ord(not odd(e)))*m0[1,e]*detr(m1,n-1);
           end;
           detr:=s;
        end
   end;

{------ a fprogram ------}
var
  m   : am;
  i,j : integer;


begin
  randomize;

  for i:=1 to max do
   begin
    for j:=1 to max do
        begin
           m[i,j]:=random(6);
          { write(m[i,j]:8:2);}
       end;
   writeln;
   end;

  writeln('Determinns szmtsa iteratv algoritmussal');
  writeln;
  writeln('A vletlen mtrix determinnsa: ', det( m, max):14:2);
  writeln;
  for i:=2 to max do
   writeln('Az ',i,'x',i,' konstans mtrix determinnsa: ', det(cam, i):14:2);

  writeln;
  writeln;
  writeln('Determinns szmtsa rekurzv algoritmussal');
  writeln;
  writeln('A vletlen mtrix determinnsa: ', det( m, max):14:2);
  writeln;
  for i:=2 to max do
   writeln('Az ',i,'x',i,' konstans mtrix determinnsa: ', det(cam, i):14:2);
end.

