(* jelszo.pas *)

program jelszo;
uses crt;

const nl = #13;
      bs = #8;

type tcharset = set of char;

{ ----------------------------------------------------
  fed    : a fedkarakter,
  okchar : karakterkszlet
}
function getpwd(fed : char; okchar : tcharset): String;
var
  ch : char;
  pwd : string;
begin
  pwd := '';
  repeat
    ch := readkey;

    if ch=#0 then  { Minden vezrlkarakter hibs }
               begin
                  ch:=readkey;
                  ch:=#1;
               end;

    if (ch=#8) and (pwd[0]<>#0) then  { Visszatrls }
               begin
                  dec(pwd[0]);
                  gotoxy(wherex-1, wherey);
                  write(' ');
                  gotoxy(wherex-1, wherey);
               end;

    if (ch in okchar) then
               begin
                 write(fed);
                 pwd := pwd + ch
               end
    else
      if not (ch in [nl, bs]) then write(^G); { sipol }
  until (ch = nl);
  getpwd := pwd
end;

var
  p : string;
begin
  writeln;
  write('Krem a betkbl ll jelszt: ');
  p := getpwd('*', ['a'..'z', 'A'..'Z']);
  writeln;
  writeln('A bert jelsz: ', p);

  writeln;
  write('Krem a szmokbl ll jelszt: ');
  p := getpwd('.', ['0'..'9']);
  writeln;
  writeln('A bert jelsz: ', p);
  readln
end.
