(* qsort.pas *)

{$M 60000,0,0}
program QuickSort_demo;
uses crt;

const
  maxelem = 30000;

type
  elem  = word;
  telem = array[1..maxelem] of elem;

{ ---------------- A QuickSort eljrs --------------- }
{ ------------ adat   : telem tpus tmb ------------ }
{ ------------ kindex : melyik indextl   ------------ }
{ ------------ vindex : melyik indexig    ------------ }

Procedure QuickSort(var adat: telem; kindex, vindex : word);
    var
      fixelem, selem  : elem;
      bindex,  jindex : word;

    begin
      bindex := kindex;
      jindex := vindex;
      fixelem := adat[(kindex + vindex) div 2];

      repeat
        { balrl jobbra a nagyobbat }
        while (adat[bindex] < fixelem) do inc(bindex);
        { jobbrl balra a kisebbet }
        while (fixelem < adat[jindex]) do dec(jindex);
        { csere }
        if (bindex <= jindex) then
          begin
             selem        := adat[bindex];
             adat[bindex] := adat[jindex];
             adat[jindex] := selem;
             inc(bindex);
             dec(jindex)
          end
      until (bindex > jindex);

      if (kindex < jindex) then
        QuickSort(adat, kindex, jindex);

      if (bindex < vindex) then
        QuickSort(adat, bindex, vindex)
end;  { QuickSort }

var
  i : Word;
  tomb  : telem;

begin
  randomize;
  write('A tmb feltltse ',maxelem, ' vletlen szmmal... ');
  for i := 1 to maxelem do
    tomb[i] := random(65535);
  writeln(' Ksz van!');

  write('A ', maxelem, ' elem tmb rendezse... ');
  QuickSort(tomb, 1, maxelem);
  writeln(' Ksz van!');

  writeln;
  writeln('Az <ENTER> lenyomsa utn megjelennek');
  writeln('a rendezett tmb elemei...');
  readln;
  for i := 1 to maxelem do
    write(tomb[i]:8)
end.
