(* kisnagyb.pas *)

{ A program az talaktst a megadott llomnyban vgzi! }

program kis_nagy_betu;
uses crt;

type puf=array[1..4*1024] of char;  { 4 Kbjt puffer }

var
  tf        :  file;
  nok, nkok : word;
  puffer    : puf;
  i         : longint;
  ch        : char;

procedure halterr(msg:string);
begin
 writeln(#7,'Futsi hiba :  ',msg);
 writeln(#7,'a program futsa megszakadt.');
 halt;
end;

begin
  { A paramterezs tesztelse }
  if paramcount<>1 then
    halterr(#13+#10+#13+#10+'Hasznlat: KISNAGYB llomny'+ #13+#10);

  { A fjl megnyitsa}
  assign(tf, paramstr(1));
  {$I-}
  reset(tf, 1);
  {$I+}
  if ioresult<>0 then
     halterr('nem elrhet fjl: '+paramstr(1));

  { kabet, nagybet, kilp }
  clrscr;
  writeln('Krem vlassza ki az talakts mdjt!:');
  writeln;
  writeln('':10,'K - kisbetss');
  writeln;
  writeln('':10,'N - nagybetss');
  writeln;
  writeln('':10,'X - kilp');
  repeat
   ch := upcase(readkey);
  until ch in ['X', 'K', 'N'];
  writeln;
  if ch = 'X' then halt;

  { Konvetrtls }
  repeat
     blockread(tf,puffer,sizeof(puf),nok);
     for i:=1 to nok do
        if ch = 'K' then
              if puffer[i] in ['A'..'Z'] then
                       puffer[i]:=chr(ord(puffer[i])+32) else
        else
              if puffer[i] in ['a'..'z'] then
                       puffer[i]:=chr(ord(puffer[i])-32);
     seek(tf,filepos(tf)-nok);
     blockwrite(tf,puffer,nok,nok);
  until (nok < sizeof(puf));

  close(tf);
end.


