(* vtomb.pas *)
program vtomb;
uses crt;

const m=100;
      n=200;
var
   f     : file of real;
   i,j,k : integer;

{ A virtulis tmb megnyitsa }
procedure vtomb_open;
begin
   assign(f,'virtomb.dat');
   rewrite(f);
end;

{ A tmb [s,o] elemnek rsa }
procedure fwrite(s,o:integer; elem:real);
var
   poz : longint;
begin
   poz:=(s-1)*longint(n)+(o-1);
   seek(f,poz);
   write(f,elem);
end;

{ A tmb [s,o] elemnek olvassa }
function fread(s,o:integer): real;
var
   elem : real;
   poz  : longint;
begin
   poz:=(s-1)*longint(n)+(o-1);
   seek(f,poz);
   read(f,elem);
   fread:=elem;
end;


begin
  writeln('A fjl megnyitsa');
  vtomb_open;

  writeln('Pozicionls az utols elemre.');
  fwrite(m,n,pi);

  writeln('A virtulis tmb feltltse.');
  for i:=1 to m do
      for j:=1 to n do
          fwrite(i,j,i*1000.0+j);

  writeln('Elemek vletlenszer kiolvassa.');
  for k:=1 to 20 do
    begin
      i:=succ(random(m-1));
      j:=succ(random(n-1));
      writeln(i:5,' ',j:5,' ',fread(i,j):10:0);
    end;
  writeln;
  writeln(1:5,' ',1:5,' ',fread(1,1):10:0);

  writeln(m:5,' ',n:5,' ',fread(m,n):10:0);
  close(f);
  erase(f);
end.
