(* obj_3.pas *)
program obj_3;
uses crt, graph;
type
  Pozicio = object
     x, y: integer;
     constructor Init( x_koord, y_koord : integer);
     procedure Rajzol;
  end;

  PTeglalap = ^Teglalap;
  Teglalap = object(Pozicio)
     a, b: integer;
     constructor Init( x_koord, y_koord,
                       a_old, b_old : integer);
     procedure Rajzol;
  end;

{ a Pozicio objektum metdusai: }
constructor Pozicio.Init;
 begin
   x:= x_koord;
   y:= y_koord;
 end;

procedure Pozicio.Rajzol;
 var
   Gd, Gm : integer;
 begin
   Gd:= VGA;
   Gm:= VGAHi;
   InitGraph(Gd, Gm, ''); { tvlt a grafikus kpernyre }
   if GraphResult <> GrOK then Halt(1);
   SetBkColor(BLUE); { a kperny kk sznre festse }
 end;

{ a Teglalap objektum metdusai: }
constructor Teglalap.Init;
 begin
   inherited Init( x_koord, y_koord);
   a:= a_old;
   b:= b_old;
 end;

procedure Teglalap.Rajzol;
 begin
   inherited  Rajzol;
   Rectangle(x, y, round(a), round(b));
   readln;
   Closegraph;
 end;

var
  pt: PTeglalap;
begin
  clrscr;
  writeln('Tglalap rajzolsa ');
  new(pt);
  pt^.Init(15,20,40,100);
  writeln('Tglalap:');
  writeln('x koordinta : ',pt^.x:3);
  writeln('y koordinta : ',pt^.y:3);
  writeln('a oldal      : ',pt^.a:3);
  writeln('b oldal      : ',pt^.b:3);
  writeln('A rajzols megkezdshez nyomjon <Enter>-t!');
  readln;
  pt^.Rajzol;
  dispose(pt);
end.