(* obj_4.pas *)
program obj_4;
uses crt, graph;

type
  Pozicio = object
    x, y: integer;
    constructor Init( x_koord, y_koord : integer);
    procedure Grafika;
    procedure Rajzol;virtual;
    destructor Done;
  end;

constructor Pozicio.Init;
 begin
   x:= x_koord;
   y:= y_koord;
end;

procedure Pozicio.Grafika;
 begin
   Rajzol;
 end;

procedure Pozicio.Rajzol;
 var
  Gd, Gm: integer;
 begin
   Gd:= VGA;
   Gm:= VGAHi;
   InitGraph(Gd, Gm, '');
   if GraphResult <> GrOK then Halt(1);
   SetBkColor(BLUE);
  end;

destructor Pozicio.Done;
 begin
 end;

type
  PTeglalap = ^Teglalap;
  Teglalap = object(Pozicio)
     a, b: integer;
     constructor Init( x_koord, y_koord: integer;
                       a_old,b_old : integer);
     procedure Rajzol; virtual;
     destructor Done;
  end;

constructor Teglalap.Init;
 begin
   inherited Init( x_koord, y_koord);
   a:= a_old;
   b:= b_old;
 end;

procedure Teglalap.Rajzol;
 begin
   inherited Rajzol;
   Rectangle(x, y, round(a), round(b));
   readln;
   Closegraph;
 end;

destructor Teglalap.Done;
 begin
 end;

var
  pt: PTeglalap;
begin
  clrscr;
  writeln('Tglalap rajzolsa');
  new(pt,init(15,20,40,100));
  writeln('x koordinta : ',pt^.x:3);
  writeln('y koordinta : ',pt^.y:3);
  writeln('a oldal      : ',pt^.a:3);
  writeln('b oldal      : ',pt^.b:3);
  writeln('A rajzols megkezdshez nyomjon <Enter>-t!');
  readln;
  pt^.Grafika;
  dispose(pt,Done);
end.