(* flist.pas *)

program flist;
uses dos;

procedure datum(time:longint);
   var
     dt : DateTime;
   begin
     Unpacktime(time,dt);
     with dt do
        begin
        write(Year:4,'-',Month:2,'-',Day:2);
        write('  ');
        write(hour:2,':',min:2,':',sec:2);
        end;
     write('  ');
   end;

procedure attributum(attr:word);
   const
     attrstr:string[6]='RHSVDA';
   var
     i   : integer;
     as  : string[7];
   begin
     as:='[';
     for i:=1 to 6 do
       if (attr and (1 shl (i-1)))<>0
         then as:=as+attrstr[i]
         else as:=as+'.';
     write(as,']  ');
   end;

var
  fadat: SearchRec;

begin
  FindFirst('c:\*.*', AnyFile, fadat);

  repeat
    if boolean(fadat.Attr and VolumeID)
     then write('Cmke    :  ')
     else
      if boolean(fadat.Attr and Directory)
       then write('Knyvtr :  ')
       else
        write('Fjl     :  ');
    attributum(fadat.Attr);
    datum(fadat.time);
    writeln(fadat.Name);
    FindNext(fadat);
  until DosError <> 0;
end.
