(* ev_diag.pas *)
program eves_diagram;
uses crt,graph;
type
     tomb12 = array[1..12] of real;
var
     ye         : tomb12;
     n          : integer;
     i          : integer;
     fsz        : string;
     evszam     : integer;
     tip        : integer;

procedure ev_diagram(t: tomb12; k: integer; sz: string;
                     ev: integer; tipus: integer);
type  s5= string[5];
      s4= string[4];
var i          :integer;
    tmax,tmin  : real;
    gd,gm      : integer;
    color      : array[1..3] of integer;
    xm,ym      : integer;
    m          : integer;
    snorm      : real;
    tsz        : integer;
    xx1,yy1    : integer;
    xx2,yy2    : integer;
    yact       : integer;
    szam,szam1 : string[6];
    x1,x2,y1,y2: integer;
    ho         : array[1..12] of s5;
    ho1        : array[1..12] of s4;
    xk         : integer;

procedure max_kereses(t: tomb12; k: integer;
                      var tmax: real;var tmin:real);
var i: integer;
begin
    tmax:=t[1];
    tmin:=t[1];
    for i:=2 to k do
    begin
      if t[i]>tmax then tmax:=t[i];
      if t[i]<tmin then tmin:=t[i];
    end;
end;

begin
   max_kereses(t,k,tmax,tmin);
   DetectGraph(gd,gm);
   case gd of
   1: begin
       gm:=1;
       xm:=319;
       ym:=199;
       color[1]:=1;
       color[2]:=2;
       color[3]:=3;
      end;
 3,4: begin
       gm:=0;
       xm:=639;
       ym:=199;
       color[1]:=cyan;
       color[2]:=lightred;
       color[3]:=lightblue;
      end;
   9: begin
       gm:=0;
       xm:=639;
       ym:=199;
       color[1]:=cyan;
       color[2]:=lightred;
       color[3]:=lightblue;
      end;
   else begin
          writeln('A display ismeretlen ');
          writeln;
          writeln('   Nyomj ENTER-t !');
          readln;
          exit;
        end;
   end;
   ho[1]:='JAN'; ho[2]:='FEBR'; ho[3]:='MARC';
   ho[4]:='APR'; ho[5]:='MAJ';  ho[6]:='JUN';
   ho[7]:='JUL';  ho[8]:='AUG';  ho[9]:='SZEPT';
   ho[10]:='OKT'; ho[11]:='NOV'; ho[12]:='DEC';
   ho1[1]:='JAN'; ho1[2]:='FEBR'; ho1[3]:='MARC';
   ho1[4]:='APR'; ho1[5]:='MAJ';  ho1[6]:='JUN';
   ho1[7]:='JUL';  ho1[8]:='AUG';  ho1[9]:='SZEP';
   ho1[10]:='OKT'; ho1[11]:='NOV'; ho1[12]:='DEC';

   initgraph(gd,gm,'');
   if gd = 1 then setbkcolor(black) else   setbkcolor(white);
   settextjustify(Centertext,Centertext);
   setcolor(color[3]);
   outtextxy(xm div 2,10,sz);
      str(ev:4,szam);
   outtextxy(xm div 2, 192, szam);

   x1:=20;
   y1:=30;
   x2:=xm-20;
   y2:=ym-30;
   if gd=1 then begin x1:=5; x2:=xm-5; end;

   settextjustify(LeftText,BottomText);
   str(tmax:6:1,szam);
   str(tmin:6:1,szam1);
   outtextxy(x1,28,'minimum: '+szam1+'    maximum: '+szam);
   rectangle(x1,y1,x2,y2+2);

   m:=y2-y1-6;
   snorm:=m/tmax;
   yact:=y2-y1;
   if gd=1 then tsz:=(x2-x1-9) div k
           else
                tsz :=(x2-x1-10) div k;
   tsz :=tsz-9;
   setcolor(2);
   xx2:=x1-8;
   if gd=1 then xx2:=-4;
   setfillStyle(9,color[2]);
   if gd=1 then  begin
                   SetTextStyle(SmallFont,HorizDir,1);
                   SetUserCharSize(13,12,14,17);
                 end;
   for i:=1 to k do
   begin
      xx1:=xx2+10;
      yy1:=y1+yact-round(ye[i]*snorm);
      xx2:=xx1+tsz;
      yy2:=y1+round(ye[i]*snorm);
      setcolor(1);
  if tipus = 1 then
                    bar3d(xx1,yy1,xx2,y2,6,true)
                else
                    begin
                      bar(xx1,yy1,xx2,y2);
                      rectangle(xx1,yy1,xx2,y2);
                    end;
      if gd=1 then xk:=xx1 else xk:=xx1+8;
      if gd=1 then outtextxy(xk,y2+12,ho1[i])
              else
                    outtextxy(xk,y2+12,ho[i]);
   end;
   readln;
   closegraph;
end;

begin
   clrscr;
   writeln('Adatok beolvassa havi bontsban ');
   writeln('Az adatok szma : 12');
   for i:=1 to 12 do
   begin
     write(i:2,'. adat : '); readln(ye[i]);
   end;
   write('A diagram fejlce : '); readln(fsz);
   write('vszm            : '); readln(evszam);
  repeat
   write('brzols: oszlop(1) tglalap (2) : ');
   readln(tip);
   writeln;
  until (tip=1) or (tip=2);
   ev_diagram(ye,12,fsz,evszam,tip);
end.