(* eljaras2.pas *)
program haromszog;
uses crt;
var
   ao, bo, co, terulet, kerulet : real;

   procedure olvas(var a,b,c: real);
   var f : boolean;
   begin
     repeat
       writeln('A hromszg oldalainak megadsa:');
       write('   A oldal: '); readln(a);
       write('   B oldal: '); readln(b);
       write('   C oldal: '); readln(c);
       if(a+b>c) and (a+c>b)
                 and (b+c>a) then f:=true
                             else
                                  begin
                                     f:=false;
                                     writeln(#7'   Hibs adatok!');
                                  end;
       writeln;
     until f;
   end;

   procedure kiir(a,b,c: real; szoveg: string; ered:real);
   begin
       writeln;
       writeln('A hromszg oldalai:');
       writeln('   A oldal :',a:10:2);
       writeln('   B oldal :',b:10:2);
       writeln('   C oldal :',c:10:2);
       writeln;
       writeln(szoveg,' ',ered:10:2);
       writeln;
       writeln('-----------  Nyomj Enter-t ! ------------');
       readln;
  end;

  procedure haromszog_kerulet(a,b,c: real; var ker:real);
  begin
     ker:=a+b+c;
  end;

  procedure haromszog_terulet(a,b,c: real; var ter:real);
  var
      s: real;
  begin
      s:=(a+b+c)/2.;
      ter:=sqrt(s*(s-a)*(s-b)*(s-c));
  end;

  { a fprogram blokkja }
  begin clrscr; { a kperny trlse }
      { a hromszg adatainak beolvassa }
      olvas(ao, bo, co);

      { a hromszg terletenek kiszmtsa }
      writeln('Az eljrs hvsa: vltozkkal ');
      haromszog_terulet(ao,bo,co,terulet);
      kiir(ao,bo,co,'A hromszg terlete: ',terulet);

     { eljrs hvsa konstanssal }
      writeln('Az eljrs hvsa: konstansokkal');
      haromszog_terulet(3,4,5,terulet);
      kiir(3,4,5,'A hromszg terlete: ',terulet);

      { eljrs hvsa kifejezssel }
      writeln('Az eljrs hvsa: kifejezsekkel');
      haromszog_terulet(ao+1,2*bo,co,terulet);
      kiir(ao+1,2*bo,co,'A hromszg terlete: ',terulet);

     { a hromszg kerletnek kiszmtsa }
     haromszog_kerulet(ao,bo,co,kerulet);
     kiir(ao,bo,co,'A hromszg kerlete:',kerulet);
end.
