unit mouse;
	{$F+,O+}
interface
 uses Dos;
 var
  egerjelen:boolean;
  gombok:word;
  oszl,sor:word;
 type
   kurzor=record
		ScreenMask,Mousemask:array[1..16] of word;
      x,y:byte;
   end;
 procedure EgerInit;
 procedure EgerLathato;
 procedure EgerLathatatlan;
 function TEgerX:word;
 function TEgerY:word;
 function Lenyomva(melyik:byte):word;
 function GEgerX:word;
 function GEgerY:word;
 procedure Megszakitas(speed:byte);
 procedure Nagykurzor(x1,y1,x2,y2:integer);
 procedure Nagykurzormegjelen;
 function Felengedve(melyik:byte):word;
 procedure Mozginfo(var x,y:integer);
 procedure Sebesseg(x:word);
 procedure pozicionalas(x,y:word);
 function Balgomb:boolean;
 function KozepsoGomb:boolean;
 function JobbGomb:boolean;
 function Gombkod:byte;
 function nincsgomb:boolean;
 procedure GrafEgerKurzor(kurz:kurzor);
 procedure GrafEgerAblak(x1,y1,x2,y2:integer);
implementation
 uses Graph;
 var
  regs:Dos.registers;
  img,mellek:pointer;
  x,y,vh,hh:integer;
 procedure EgerInit;
 begin
  regs.AX:=0;
  Dos.Intr($33,regs);
  egerjelen:=regs.ax=$FFFF;
  gombok:=regs.BX;
 end;
 procedure EgerLathato;
 begin
  regs.AX:=1;
  Dos.Intr($33,regs);
 end;
 procedure EgerLathatatlan;
 begin
  regs.AX:=2;
  Dos.Intr($33,regs);
 end;
 function TEgerX:word;
 begin
  regs.AX:=3;
  Dos.Intr($33,Regs);
  TEgerX:=regs.CX div 8+1;
 end;
 function TEgerY:word;
 begin
  regs.AX:=3;
  Dos.Intr($33,Regs);
  TEgerY:=regs.DX div 8+1;
 end;
 function lenyomva;
 begin
  regs.AX:=5;
  regs.BX:=melyik;
  Intr($33,regs);
  lenyomva:=regs.BX;
 end;
 function felengedve;
 begin
  regs.AX:=6;
  regs.BX:=melyik;
  Intr($33,regs);
  felengedve:=regs.BX;
 end;
 function GEgerX;
 begin
  regs.AX:=3;
  Dos.Intr($33,Regs);
  GEgerX:=Round(oszl/640*regs.CX);
 end;
 function GEgerY;
 begin
  regs.AX:=3;
  Dos.Intr($33,Regs);
  GEgerY:=Round(sor/480*regs.DX);
 end;
 procedure Megszakitas;
 begin
  regs.AX:=28;
  regs.BX:=2;
  regs.cX:=speed;
  Intr($33,regs);
 end;
 procedure nagykurzor;
 begin
   GetMem(img,ImageSize(x1,y1,x2,y2));
   GetMem(mellek,ImageSize(x1,y1,x2,y2));
   GetImage(x1,y1,x2,y2,mellek^);
   GetImage(x1,y1,x2,y2,img^);
   x:=GEgerX;
   y:=GEgerY;
   vh:=y2-y1+1;
   hh:=x2-x1+1;
 end;
 procedure Nagykurzormegjelen;
 begin
 	PutImage(x,y,mellek^,normalput);
   x:=GEgerX;
   y:=GEgerY;
   GetImage(x,y,x+hh,y+vh,mellek^);
   PutImage(x,y,img^,NormalPut);
 end;
 procedure Mozginfo;
 begin
   regs.AX:=11;
   Intr($33,regs);
   x:=regs.cx;
   y:=regs.dx;
 end;
 procedure sebesseg;
 begin
 	regs.ax:=19;
   regs.cx:=x;
   Intr($33,regs);
 end;
 procedure pozicionalas;
 begin
 	regs.AX:=4;
   regs.CX:=x;
   regs.DX:=y;
   Intr($33,regs);
 end;
 function Balgomb;
 begin
   regs.AX:=3;
   Intr($33,regs);
   Balgomb:=regs.Bx in [1,3,5,7];
 end;
 function Jobbgomb;
 begin
   regs.AX:=3;
   Intr($33,regs);
   Jobbgomb:=regs.Bx in [2,3,6,7];
 end;
 function Kozepsogomb;
 begin
   regs.AX:=3;
   Intr($33,regs);
   Kozepsogomb:=regs.Bx in [4,5,6,7];
 end;
 function gombkod;
 begin
   regs.AX:=3;
   Intr($33,regs);
   gombkod:=regs.Bx;
 end;
 function nincsgomb;
 begin
   regs.AX:=3;
   Intr($33,regs);
   nincsgomb:=regs.Bx=0;
 end;
 procedure GrafEgerKurzor;
 begin
    regs.AX:=9;
    regs.BX:=kurz.x;
    regs.CX:=kurz.y;
    regs.DX:=ofs(kurz.screenmask);
    regs.ES:=Seg(kurz.screenmask);
    Intr($33,regs);
 end;
 procedure GrafEgerAblak;
 begin
   regs.AX:=7;
   regs.CX:=x1;
   regs.DX:=x2;
   Intr($33,regs);
   regs.AX:=8;
   regs.CX:=y1;
   regs.DX:=y2;
   Intr($33,regs);
 end;
begin
	oszl:=640;
   sor:=480;
end.





















