unit TMap;
interface
	type
      point=record
      	x,y:real;
      end;
   var
   	MappingImage:array[1..30000] of byte;
   procedure TextureMapping(A,B,C,D:point;szel,mag:integer;nonvColor:word);
   procedure TextureFilling(repeats:byte;A,B,C,D:point;szel,mag:integer;nonvColor:word);
implementation
	uses graph;
   function Round(x:real):longint;
   begin
      if x>maxlongint then round:=maxlongint
      else
      if x<-maxlongint-1 then round:=-maxlongint-1
      else
      	Round:=system.Round(x);

   end;
   procedure TextureMapping;
   	var
         AB,AD,DC,BC,SUB:point;
         p1,p2,p3,p4:point;
         x,y:real;
         i,j,k:word;
         MappingPix:array[1..5] of PointType;
         rajz:boolean;
   begin
      AB.x:=B.x-A.x;
      AB.y:=B.y-A.y;
      AD.x:=D.x-A.x;
      AD.y:=D.y-A.y;
      DC.x:=C.x-D.x;
      DC.y:=C.y-D.y;
      BC.x:=C.x-B.x;
      BC.y:=C.y-B.y;
      x:=A.x;
      y:=A.y;
      for j:=1 to mag do
      	for i:=1 to szel do
         begin
         	rajz:=true;
            SUB.x:=(DC.x/mag*(j-1)+D.x)-(AB.x/mag*(j-1)+A.x);
            SUB.y:=(DC.y/mag*(j-1)+D.y)-(AB.y/mag*(j-1)+A.y);
            p1.x:=SUB.x/szel*(i-1)+x+(AB.x/mag*(j-1));
            p1.y:=SUB.y/szel*(i-1)+y+(AB.y/mag*(j-1));
            p4.x:=SUB.x/szel*i+x+(AB.x/mag*(j-1));
            p4.y:=SUB.y/szel*i+y+(AB.y/mag*(j-1));
            SUB.x:=(DC.x/mag*j+D.x)-(AB.x/mag*j+A.x);
            SUB.y:=(DC.y/mag*j+D.y)-(AB.y/mag*j+A.y);
            p2.x:=SUB.x/szel*(i-1)+x+(AB.x/mag*(j));
            p2.y:=SUB.y/szel*(i-1)+y+(AB.y/mag*(j));
            p3.x:=SUB.x/szel*i+x+(AB.x/mag*(j));
            p3.y:=SUB.y/szel*i+y+(AB.y/mag*(j));
            SetFillStyle(1,mappingImage[(j-1)*szel+i]);
            SetColor(Mappingimage[(j-1)*szel+i]);
            if GetColor=NonVColor then continue;
            MappingPix[1].x:=Round(p1.x);
            MappingPix[1].y:=Round(p1.y);
            MappingPix[2].x:=Round(p2.x);
            MappingPix[2].y:=Round(p2.y);
            MappingPix[3].x:=Round(p3.x);
            MappingPix[3].y:=Round(p3.y);
            MappingPix[4].x:=Round(p4.x);
            MappingPix[4].y:=Round(p4.y);
            MappingPix[5]:=MappingPix[1];
            for k:=1 to 5 do
            begin
               if (MappingPix[k].x>GetMaxX) or (MappingPix[k].x<0) or (MappingPix[k].y>GetMaxY) or (MappingPix[k].y<0) then
               begin
               	rajz:=false;
                  Break;
               end;
            end;
            if rajz then FillPoly(5,MappingPix);
         end;
   end;
   procedure TextureFilling;
   	var
         AB,AD,DC,BC,SUB:point;
         p1,p2,p3,p4:point;
         x,y:real;
         i,j,k:word;
         MappingPix:array[1..5] of PointType;
         rajz:boolean;
         szel2:integer;
   begin
      AB.x:=B.x-A.x;
      AB.y:=B.y-A.y;
      AD.x:=D.x-A.x;
      AD.y:=D.y-A.y;
      DC.x:=C.x-D.x;
      DC.y:=C.y-D.y;
      BC.x:=C.x-B.x;
      BC.y:=C.y-B.y;
      x:=A.x;
      y:=A.y;
      szel2:=szel*repeats;
      for j:=1 to mag do
      	for i:=1 to szel2 do
         begin
         	rajz:=true;
            SUB.x:=(DC.x/mag*(j-1)+D.x)-(AB.x/mag*(j-1)+A.x);
            SUB.y:=(DC.y/mag*(j-1)+D.y)-(AB.y/mag*(j-1)+A.y);
            p1.x:=SUB.x/szel2*(i-1)+x+(AB.x/mag*(j-1));
            p1.y:=SUB.y/szel2*(i-1)+y+(AB.y/mag*(j-1));
            p4.x:=SUB.x/szel2*i+x+(AB.x/mag*(j-1));
            p4.y:=SUB.y/szel2*i+y+(AB.y/mag*(j-1));
            SUB.x:=(DC.x/mag*j+D.x)-(AB.x/mag*j+A.x);
            SUB.y:=(DC.y/mag*j+D.y)-(AB.y/mag*j+A.y);
            p2.x:=SUB.x/szel2*(i-1)+x+(AB.x/mag*(j));
            p2.y:=SUB.y/szel2*(i-1)+y+(AB.y/mag*(j));
            p3.x:=SUB.x/szel2*i+x+(AB.x/mag*(j));
            p3.y:=SUB.y/szel2*i+y+(AB.y/mag*(j));
            SetFillStyle(1,mappingImage[(j-1)*szel+(i mod szel)]);
            SetColor(Mappingimage[(j-1)*szel+(i mod szel)]);
            if GetColor=NonVColor then continue;
            MappingPix[1].x:=Round(p1.x);
            MappingPix[1].y:=Round(p1.y);
            MappingPix[2].x:=Round(p2.x);
            MappingPix[2].y:=Round(p2.y);
            MappingPix[3].x:=Round(p3.x);
            MappingPix[3].y:=Round(p3.y);
            MappingPix[4].x:=Round(p4.x);
            MappingPix[4].y:=Round(p4.y);
            MappingPix[5]:=MappingPix[1];
            for k:=1 to 5 do
            begin
               if (MappingPix[k].x>GetMaxX) or (MappingPix[k].x<0) or (MappingPix[k].y>GetMaxY) or (MappingPix[k].y<0) then
               begin
               	rajz:=false;
                  Break;
               end;
            end;
            if rajz then FillPoly(5,MappingPix);
         end;
   end;

end.