(* TESZT.PAS *)
{$R+}
{$M 60000,0,655360}

program teszt;
uses crt, stopper, rendez;
const
  maxn = 10000;

type
  ttomb = array[1..maxn] of integer;
var
  a, b : ttomb;
  e    : integer;

procedure feltoltes(var t : ttomb; db : integer);
 var
   i : integer;
 begin
   for i:=1 to db do
      t[i]:=random(maxint);
 end;

begin
  randomize;
  clrscr;
  writeln('Az elemek szma: ',maxn:6);
  writeln;

  write('Feltlts            :   ');
  start;
  feltoltes(b,maxn);
  stop;
  writeln(Leolvas(1000):10:2,' ms');

  a:=b;
  write('Bubork rendezs     :   ');
  start;
   rbuborek(a,maxn);
  stop;
  writeln(Leolvas(1000):10:2,' ms');

  a:=b;
  write('Shell-rendezs       :   ');
  start;
   rshell(a,maxn);
  stop;
  writeln(Leolvas(1000):10:2,' ms');

  a:=b;
  write('Gyorsrendezs        :   ');
  start;
   rgyors(a,maxn);
  stop;
  writeln(Leolvas(1000):10:2,' ms');

  write('Szekvencilis keress:   ');
  start;
   e:=sorkeres(a,a[maxn],maxn);
  stop;
  writeln(Leolvas(1000):10:2,' ms');

  write('Binris keress      :   ');
  start;
   e:=sorkeres(a,a[maxn],maxn);
  stop;
   writeln(Leolvas(1000):10:2,' ms');

   readln;
end.