(* ora.pas *)
program ora;

uses crt,graph;

const aspect:real=1.0;

var
   gd, gm,d : integer;
   xc,yc,r,i: integer;


function ar(y:word):word;
begin
    ar:=round(aspect*y);
end;


procedure setaspect;
var
    d,m:word;
begin
    getaspectratio(d,m);
    aspect:=1.0*d/m;
end;

procedure linex(x1,y1,x2,y2:word);
begin
  line(x1,ar(y1),x2,ar(y2));
end;

begin
    detectgraph(gd,gm);
    initgraph(gd,gm,'');

    setaspect;
    xc:=getmaxx div 2;
    yc:=getmaxy div 2;
    r :=(xc+yc) div 4;
    d :=(xc+yc) div 64;
    setbkcolor(blue);
    setcolor(yellow);

    setlinestyle(solidln,0,3);
    circle(xc,ar(yc),r);

    for i:=1 to 12 do
     linex(xc+round((r-4*d)*cos(i*pi/6)),
           yc+round((r-4*d)*sin(i*pi/6)),
           xc+round((r-d)*cos(i*pi/6)),
           yc+round((r-d)*sin(i*pi/6)));

    i:=-20;
    linex(xc+round((-d)*cos(i*pi/30)),
          yc+round((-d)*sin(i*pi/30)),
          xc+round((r-5*d)*cos(i*pi/30)),
          yc+round((r-5*d)*sin(i*pi/30)));

    i:=24;
    linex(xc+round((-d)*cos(i*pi/30)),
          yc+round((-d)*sin(i*pi/30)),
          xc+round((r-10*d)*cos(i*pi/30)),
          yc+round((r-10*d)*sin(i*pi/30)));


    setlinestyle(solidln,0,0);

    for i:=1 to 60 do
     linex(xc+round((r-2*d)*cos(i*pi/30)),
           yc+round((r-2*d)*sin(i*pi/30)),
           xc+round((r-d)*cos(i*pi/30)),
           yc+round((r-d)*sin(i*pi/30)));

    i:=3;
    linex(xc+round((-d)*cos(i*pi/30)),
          yc+round((-d)*sin(i*pi/30)),
          xc+round((r-5*d)*cos(i*pi/30)),
          yc+round((r-5*d)*sin(i*pi/30)));

    setfillstyle(solidfill,yellow);
    bar(xc-5*d,ar(yc+7*d),xc+5*d,ar(yc+9*d));

    setcolor(blue);
    settextstyle(smallfont, horizdir, ar(6));
    outtextxy(xc-4*d,ar(yc+7*d),'19:55');
    settextstyle(smallfont, horizdir, ar(5));
    outtextxy(xc+3*d,ar(yc+7*d),'18');
    readln;
end.
