{$M 32768,0,655350}
program spiralrajz;
uses graph, crt;

{ rekurzv spirlrajzol }
procedure spiral(d, minx, miny, maxx, maxy : integer);
begin
  if (abs(maxy-miny)<=d) or (abs(maxx-minx)<=d)  then exit;
  moveto(minx,miny);
  lineto(maxx, miny);
  lineto(maxx,maxy);
  lineto(minx,maxy);
  lineto(minx, miny+d);
  lineto(minx+d,miny+d);
  spiral(d,minx+d, miny+d, maxx-d, maxy-d);
end;


{ nem rekurzv spirlrajzol }
procedure teglak(d, minx, miny, maxx, maxy : integer);
var
  n, nx, ny, i : integer;
  col0, col1 : byte;
begin
  nx:=abs(maxx-minx) div (2*d);
  ny:=abs(maxy-miny) div (2*d);
  n :=ny;
  if nx<n then n:=nx;
  if (abs(maxy-miny-2*n*d)<d) or (abs(maxx-minx-2*n*d)<d)  then dec(n);
  col0:=getbkcolor;
  col1:=getcolor;
  for i:=0 to n do
     begin
       rectangle(minx+i*d, miny+i*d, maxx-i*d, maxy-i*d);
       moveto(minx+i*d, miny+i*d+1);
       setcolor(col0);
       lineto(minx+i*d, miny+(i+1)*d);
       setcolor(col1);
       lineto(minx+(i+1)*d, miny+(i+1)*d);
     end;
end;

var
   gd, gm : integer;
   d      : integer;
begin
 textbackground(blue);
 clrscr;
 repeat
   write('Krem a lpstvolsgot: ');
   readln(d);
 until (d>=1) and (d<=128);

 detectgraph(gd,gm);
 initgraph(gd,gm,'c:\tc');
 setbkcolor(blue);
 setcolor(yellow);
 spiral(d, 0, 0, getmaxx, getmaxy);
 readln;
 cleardevice;
 teglak(d, 0, 0, getmaxx, getmaxy);
 readln;
 cleardevice;
 spiral(d, 10, 10, getmaxx div 2, getmaxy div 2);
 teglak(d, 10, getmaxy div 2+10, getmaxx div 3, getmaxy);
 readln;

 cleardevice;

 repeat
   setbkcolor(random(getmaxcolor+1));
   setcolor(random(getmaxcolor+1));
   teglak(1,0,0,getmaxx,getmaxy);
   delay(100);
 until keypressed;
 readkey;
 readln;
 closegraph;
 restorecrtmode;
end.
