(* MTESZT.PAS *)

{-----------------------------------------------------------------
  Az OOPMOUSE modul hasznlatt bemutat program
 -----------------------------------------------------------------}

program OOPMOUSE_TESZT;

uses graph, oopmouse;

const szoveg:array[1..6] of string[8] = (
    { a vlaszthat grafikus kurzorok:}   'Nyl',
                                          'Pipa',
                                          'Kereszt',
                                          'Kz',
                                          'I-rd',
    { a kilps                       }   ' ESC '
                                        );

const  grdriver=ega;
       grmode=egahi;
       boxxl=58;
       boxyl=42;
       boxx=80;
       boxy=40;

var graphdriver, graphmode:integer;
    m                     :graphicmouse;
    mstatus               :boolean;
    mgombok               :integer;
    bb,bx,by              :integer;
    i                     :word;

begin

  { a grafikus kperny inicializlsa s a men megjelentse }

  graphdriver:=grdriver;
  graphmode  :=grmode;

  initgraph(graphdriver, graphmode, '');
  setbkcolor(black);
  setfillstyle(solidfill,white);
  for i:=1 to 6 do
  begin
    bar(i*boxx,boxy,i*boxx+boxxl,boxy+boxyl);
    setcolor(white);
    rectangle(i*boxx-2,boxy-2,i*boxx+boxxl+2,boxy+boxyl+2);
    setcolor(black);
    setviewport(i*boxx,boxy,i*boxx+boxxl,boxy+boxyl,true);
    SetTextStyle(DefaultFont, HorizDir,1);
    settextjustify(centertext,centertext);
    outtextxy(boxxl div 2,boxyl div 2,szoveg[i]);
    setviewport(0,0,getmaxx,getmaxy,true);
  end;

  { az egr inicializlsa }

  with m do
  begin
    reset(mstatus, mgombok);
    if not mstatus
    then begin
           closegraph;
           halt;
         end;
    initialize;
    setcursor(arrow);
    show(true);

    { a men }
    repeat
      getposition(bb,bx,by);
      if bb=1
      then begin
             i:=0;
             repeat
              inc(i);
             until (i=7) or
                   ((bx>i*boxx-2) and (bx<i*boxx+boxxl+2) and
                    (by>boxy-2)   and (by<boxy+boxyl+2));
             if i<7
             then begin
                    case i of
                      1:setcursor(arrow);
                      2:setcursor(check);
                      3:setcursor(cross);
                      4:setcursor(glove);
                      5:setcursor(ibeam);
                      6:begin
                          closegraph;
                          halt;
                         end;
                    end;
                    show(true);
                  end;
           end;
    until false;
  end;
end.
