(* pt3.pas *)
program pt3;
uses crt;

type
  kmutato  = ^karakter;
  karakter = record
                ch : char;
                kovetkezo : kmutato;
             end;
var
  str_ptr,             { mutato a karakterlnc kezdetre }
  char_ptr : kmutato;  { mutato a lnc valamely elemhez }
  mem0     : longint;

{ karakter beolvassa a billentyzetrl s hozzfzse a lnchoz: }
procedure char_read(var list_ptr : kmutato);
 var k : char;
 begin
   k:=readkey;
   if ord(k) in [32..255]
      then
         begin
            write(k);
            new(list_ptr);
            list_ptr^.ch:= k;
            list_ptr^.kovetkezo:= nil;
         end
      else list_ptr:=nil;
end;

{ karaktersorozat beolvassa a billentyzetrl: }
procedure str_read(var list_ptr : kmutato);
 var tmp_ptr : kmutato;
 begin
  char_read(list_ptr);       { az els karakter bevitele }
  tmp_ptr:= list_ptr;
  while tmp_ptr<>nil do
    begin
      char_read(tmp_ptr^.kovetkezo);
      tmp_ptr:= tmp_ptr^.kovetkezo;
    end;
 end;

{ a karakterlnc megjelentese a kpernyn: }
procedure char_print(list_ptr : kmutato);
 begin
   writeln;
   while list_ptr<>nil do
   begin
     write(list_ptr^.ch);
     list_ptr:= list_ptr^.kovetkezo;
   end;
   writeln;
 end;

{ a karakterlnc hossznak lekrdezse: }
function str_len(list_ptr : kmutato):integer;
 var h:integer;
 begin
   h:=0;
   while list_ptr<>nil do
   begin
     inc(h);
     list_ptr:=list_ptr^.kovetkezo;
   end;
   str_len:=h;
 end;

{ a karakterlnc megszntetse: }
procedure str_free(list_ptr : kmutato);
 var str_ptr : kmutato;
 begin
   while list_ptr<>nil do
   begin
     str_ptr:=list_ptr^.kovetkezo;
     dispose(list_ptr);
     list_ptr:=str_ptr;
   end;
 end;

{ a fprogram }
begin
  clrscr;
  mem0:=memavail;      { a kiindulsi heapmret }

  write('Krek egy karaktersorozatot: ');
  str_read(str_ptr);   { a sztring beolvassa s trolsa }

  char_print(str_ptr); { a karakterlnc kirsa }
  writeln('A sztring hossza    : ',str_len(str_ptr):5,' bjt');
  writeln('A lefoglalt terlet : ',mem0-memavail:5,' bjt');

  str_free(str_ptr);   { a sztring trlse a memribl }
end.
