(* rajz_m.pas *)
program rajz_m;
uses graph,crt;
var
    a,b        : integer;  { a tglalap oldalai }
    gd,gm,gr   : integer;
    x,y        : integer;  { a beltets koordinti }
    szin1,szin2: word;
    Xasp,Yasp  : word;
    maxX,MaxY  : integer;

procedure olvas(szoveg: string;sor: integer; var w: integer);
 var
   sz  : string;
   code: integer;
   ch  : char;
   x,y : byte;
 begin
   repeat
     repeat
        TextColor(White);
        GotoXY(2,10+sor);
        write(szoveg); ClrEol;
        x:=WhereX; y:=WhereY;
        TextColor(Yellow);
        readln(sz);
        val(sz,w,code);
        if code <>0 then begin
                           gotoXY(x+4,y);
                           TextColor(Red+Blink);
                           write('Hibs adat!: Szkz');
                           sound(100); Delay(150);
                           NoSound;
                           repeat until Keypressed;
                           gotoXY(2,10+sor);
                           DelLine;
                         end;
     until code=0;

     repeat
       gotoxy(2,12+sor);
       TextColor(Green);
       write('Akarja javitani (i/n): '); ch:=ReadKey;
     until (ch='i') or (ch='n');
     gotoXY(2,12+sor); delline;
   until ch='n';
 end;

begin
  { Szveges zemmd belltsa }
   TextMode(C40);
   TextBackground(blue); { httr szne }
   clrscr;
   GotoXY(2,5);
   TextColor(Magenta); { rs szne }
   write('Tglalap adatai');
   olvas('a oldal: ',0,a);
   olvas('b oldal: ',2,b);
   GotoXY(2,14);
   TextColor(Magenta);
   write('Bal fels (x,y) sarokpontja: ');
   olvas('x : ',6,x);
   olvas('y : ',8,y);

   { grafikus zemmdra vlts }
   DetectGraph(gd,gm);

   case gd of
   CGA:      begin { CGA }
               gm:=CGAC1;
               szin1:=1;
               szin2:=2;
             end;
   EGA:      begin { EGA }
               gm:=EGALo;
               szin1:=Red;
               szin2:=Blue;
             end;
   EGA64:    begin { EGA64 }
               gm:=EGA64Lo;
               szin1:=Red;
               szin2:=Blue;
             end;
   HercMono: begin { Hercules }
               gm:=HercMonoHi;
               szin1:=1;
               szin2:=1;
             end;
   VGA:      begin  { VGA }
               gm:=VGAHi;
               szin1:=Red;
               szin2:=Blue;
             end;
   end;
   InitGraph(gd,gm,'');     { grafikus mdba vlts }
   gr := GraphResult;
   if gr = grOK then
     begin
       if gd <> HercMono then SetBkColor(Cyan);    { a httr szne }

       SetColor(szin1);       { a fejlc szne }
       { a szveg elhelyezse a koordintapont krl }
       SetTextJustify(CenterText,BottomText);
       { a szveg stlusa, irnya s nagysga }
       SetTextStyle(DefaultFont,HorizDir,1);
       maxX:=GetMaxX;
       maxY:=GetMaxY;
       if a=b then  OutTextXY(MaxX div 2,15,'Ngyzet rajzolsa')
              else  OutTextXY(MaxX div 2,15,'Tglalap rajzolsa');

       SetColor(szin2);         { az bra szne }
       if a=b then begin        { ngyzet rajzolsa }
                    GetAspectRatio(Xasp,Yasp);
                    b:=Round((Xasp/Yasp)*a); { torzits szmtsa}
                   end;
       Rectangle(x,y,a+x,b+y); { ha a<> b : tglalap rajzolsa }

       SetColor(szin1);          { az zenet szne }
       SetTextStyle(DefaultFont,HorizDir,1);
       OutTextXY(maxX div 2,maxY-10,'Nyomjon <Enter>-t');
       readln;
       RestoreCrtMode;
       TextBackground(blue); { httr szne }
       clrscr;
       GotoXY(2,5);
       TextColor(Magenta); { irs szne }
       write('A kr adatai: ');
       olvas('sugr: ',0,a);
       GotoXY(2,14);
       TextColor(Magenta);
       write('A kr kzppontja (x,y): ');
       olvas('x : ',4,x);
       olvas('y : ',6,y);
       SetGraphMode(GetGraphMode);
       if gd <> HercMono then SetBkColor(Cyan);    { a httr szne }
       SetColor(szin1);       { a fejlc szne }
       { a szveg elhelyezse a koordinatpont krl }
       SetTextJustify(CenterText,BottomText);
       { a szveg stilusa, irnya s nagysga }
       SetTextStyle(DefaultFont,HorizDir,1);
       maxX:=GetMaxX;
       maxY:=GetMaxY;
       OutTextXY(MaxX div 2,15,'Kr rajzolsa');

       SetColor(szin2);         { az bra szne   }
       circle(x,y,a);           { a kr rajzolsa }
       SetColor(szin1);         { az zenet szne }
       SetTextStyle(DefaultFont,HorizDir,1);
       OutTextXY(maxX div 2,maxY-10,'Nyomjon <Enter>-t');
       readln;
       Closegraph;
     end
    else
     begin
       writeln('Grafikus hiba: ',GraphErrorMsg(gr));
       readln;
       halt(1);
     end;
end.