(* VGA256.PAS *)

program VGA256_SCRIPT;
uses  Crt, Graph;
var
  gvezerlo , gmod, hibakod, c, gfont : integer;

{ Az automatikus felismerskor meghvd far eljrs }
function DetectVGA256 : integer; far;
var
  gvezerlo : integer;
  gmod  : integer;
begin
  DetectGraph(gvezerlo, gmod);
  if (gvezerlo = VGA) then DetectVGA256 := 0   { 256 szn md }
                      else DetectVGA256 := grError; { hiba }
end;

begin
    { a VGA256.BGI vezrl beillesztse a vezrltblba}
    gvezerlo := InstallUserDriver('VGA256', @DetectVGA256);
    { a SCRI.CHR karakterkszlet teleptse}
    gfont := InstallUserFont('SCRI');

    { A  320x200, 256 szn grafika inicializlsa}
    gvezerlo := Detect;
    InitGraph(gvezerlo, gmod, '');
    hibakod := GraphResult;
    if hibakod <> grOK then
    begin
      Writeln('Grafika hiba: ', GraphErrorMsg(hibakod));
      halt(1);
    end;

  { a teleptett karakterkszlet felhasznlsa }
  SetTextStyle(gfont, HorizDir, 7);
  SetTextJustify(CenterText, CenterText);

  for c:=0 to 255 do
   begin
      SetFillStyle(SolidFill, c);
      Bar(0+c*1,0,(c+1)*1, GetMaxy)
   end;
  SetColor(Black);
  Rectangle(60,60,240,140);
  SetColor(Blue);
  OutTextXY(150, 80, 'Dvid');
  readln;
  CloseGraph;
end.
