(* maskinp.pas *)

program MaskInput;

Uses Crt;


{ str  : a bevitt sztringet adja vissza }
{ mask : a inputmaszk, melynek elemei: 'A'- bet, '0' - szm,
                                       #32 - brmi           }
{ fill : helykitlt karakter }

Procedure MReadLn(Var str : String; mask : String; fill : Char);
Const
  maskset = ['0', 'A', #32];
Var
  ch : Char;
  sp, { startpozci }
  wx, wy : Byte;
Begin
  str := '';
  wx := WhereX; wy := WhereY;

  { Az inputmez kirsa }
  for sp:=1 to Length(mask) Do
    If (mask[sp] In maskset) Then Write(fill)
      Else If (mask[sp] = '_') Then  Write(' ')
         Else Write(mask[sp]);

  { A maszk elejn lev nem input karakterek str-be msolsa }
  sp := 0;
  While (Not (mask[sp + 1] In maskset)) And (sp < Length(mask)) Do
    Begin
      Inc(sp);
      str := str + mask[sp];
    End;
  { s tlpse }
  GotoXY(wx + sp, wy);

  Repeat
    ch := ReadKey;

    If (ch = #8) Then { visszatrls }
      Begin
         If (Length(str) > sp) Then  {csak a kezdpozciig!}
           Begin
              If Not (mask[Length(str)] IN maskset) Then
                { a fix maszk karakterek tlpse }
                Begin
                   Repeat
                     Dec(str[0]);
                     GotoXY(WhereX - 1, WhereY);
                   Until (Length(str) <= sp) OR (mask[Length(str)] In maskset);
                End;
              { az aktulis nem maszk karakter trlse }
              Dec(str[0]);
              GotoXY(WhereX - 1, WhereY);
              Write(fill);
              GotoXY(WhereX - 1, WhereY);
          End
         Else
          Begin
            Sound(440);
            Delay(80);
            NoSound;
          End;
       End

      Else {nem backslash!}
       If (Length(str) < Length(mask)) Then
        Begin
           { a maszk ellenrzse }
           Case mask[Length(str) + 1] Of
              '0' : If ch In ['0'..'9'] Then
                      Begin
                        Write(ch);
                        str := str + ch;
                      End;
              'A' : If UpCase(ch) In ['A'..'Z'] Then
                      Begin
                        Write(ch);
                        str := str + ch;
                      End;
              #32 : Begin
                      Write(ch);
                      str := str + ch;
                    End;
           End;
        { a fix karakterek tlpse, _ a szkzt jelenti !}
        While (Length(str) < Length(mask)) And
              (Not (mask[Length(str) + 1] In maskset)) Do
           Begin
              If (mask[Length(str) + 1] = '_')
                   Then str := str + ' '
                   Else str := str + mask[Length(str) + 1];
              GotoXY(WhereX + 1, WhereY);
           End;
      End;
  Until (ch In [#13, #27]);
End;

Var
  ts : String;

Begin
  ClrScr;
  Write('Nv           : ');
  MReadLn(ts, 'Blaise_                       ', '_');
  WriteLn;
  Write('Telefonszm   : ');
  MReadLn(ts, '000-00-00', '.');
  WriteLn;
  Write('Szemlyi szm : ');
  MReadLn(ts, '0_000000_0000', '?');
  WriteLn;
  Write('Mai dtum     : ');
  MReadLn(ts, '1900.00.00', '_');
  WriteLn;
  ReadLn;
End.


