(* matrix.pas *)
program matrix;
uses crt;

const
     maxn=10;
type
     ttomb = array[1..maxn,1..maxn] of integer;
const
     ctomb:ttomb=( (1, 2, 3, 4, 5, 6, 7, 8, 9, 10),
                   (1, 2, 3, 4, 5, 6, 7, 8, 9, 10),
                   (1, 2, 3, 4, 5, 6, 7, 8, 9, 10),
                   (1, 2, 3, 4, 5, 6, 7, 8, 9, 10),
                   (1, 2, 3, 4, 5, 6, 7, 8, 9, 10),
                   (1, 2, 3, 4, 5, 6, 7, 8, 9, 10),
                   (1, 2, 3, 4, 5, 6, 7, 8, 9, 10),
                   (1, 2, 3, 4, 5, 6, 7, 8, 9, 10),
                   (1, 2, 3, 4, 5, 6, 7, 8, 9, 10),
                   (1, 2, 3, 4, 5, 6, 7, 8, 9, 10));


procedure mkiir(m:ttomb; n:integer);
  var
     i,j : integer;
  begin
     for i:=1 to n do
         begin
           for j:=1 to n do
               write(m[i,j]:6);
           writeln;
         end;
  end;


procedure mtrans(var m:ttomb; n:integer);
  var
     i,j : integer;
     sv  : integer;
  begin
    for i:=1 to n-1 do
        for j:=i+1 to n do
            begin
              sv     := m[i,j];
              m[i,j] := m[j,i];
              m[j,i] := sv;
            end;
  end;



var
    n     : integer;
    tomb  : ttomb;

begin
  clrscr;
  write('Az elemek szma [max 10]: ');
  readln(n);
  if not(n in [1..10]) then halt;
  tomb:=ctomb;

  mkiir(tomb,n);
  mtrans(tomb,n);
  writeln;
  mkiir(tomb,n);

end.