(* lsor.pas *)

{  Sor (queue) adatszerkezet megvalstsa lista segtsgvel }
{  a listaelem szerkezete: infolink                        }

program lsor;
uses crt;

type
   tadat = word;
   qeptr = ^qelem;
   qelem = record
	     info  : tadat;
	     link : qeptr;
           end;

const
     pvege  : qeptr = nil;   { res sor }
     peleje : qeptr = nil;

{ hibajelzs helyett nil pointer }
function HeapFunc(size:tadat) :integer; far;
 begin
   heapfunc:=1;
 end;

{ adat bevitele a verembe }
procedure betesz(adat : tadat);
var
  sv : qeptr;
begin
  new(sv);
  if (sv = nil) then
	          begin
		    writeln(#7'Queue overflow');
		    exit;
	          end;
  if (pvege = nil) then
		   begin
		     sv^.link := nil;
		     sv^.info  := adat;
		     pvege  := sv;
		     peleje := sv;
		   end
	         else
		   begin
		     sv^.info := adat;
		     sv^.link := nil;
		     pvege^.link := sv;
		     pvege := sv;
		   end;
  writeln(adat:6, ' bevitele megtrtnt.');
end;


function kivesz(var adat : tadat) : boolean;
var
  sv : qeptr;
begin
  if (peleje = nil) then
	              begin
		        writeln(#7'Queue underflow');
                        kivesz:= false;
		        exit;
	              end;

  sv     := peleje;
  adat   := peleje^.info;
  peleje := peleje^.link;
  dispose(sv);
  if peleje = nil then pvege:=nil; { kirlt a sor }
  writeln(adat:6, ' kivtele megtrtnt.');
  kivesz:= true;
end;

var
  adatelem : tadat;
        i : integer;

{ fprogram }
begin
  HeapError:=@HeapFunc;

  clrscr;
  { adatok bevitele a sorba }
  for i := 1 to 4 do
     betesz(i*i);

  writeln;
  { adatok kivtele a sorbl}
  for i := 1 to  2 do
     kivesz(adatelem);

  writeln;
  { adatok bevitele a sorba }
  for i := 10 to 13 do
     betesz(i*i);

  writeln;
  { adatok kivtele a sorbl}
  for i := 1 to  7 do
     kivesz(adatelem);

end.



