(* tverem.pas *)

{  Verem (stack) adatszerkezet megvalstsa vektor segtsgvel }

program tverem;
uses crt;

const
   veremmeret = 100;
   teteje : word = 0;   { veremmutat, res stack }

type
  tadat = longint;

var
   stack: array [1..veremmeret] of tadat;

{ adat bevitele a verembe }
procedure betesz(adat : tadat);
 begin
   if teteje = veremmeret then
	                     begin
	                       writeln(#7'Stack overflow');
	                       exit;
	                     end;
   inc(teteje);
   stack[teteje] := adat;
   writeln(adat:6, ' bevitele megtrtnt.');
 end;

{ adat kivtele a verembl}
function kivesz(var adat : tadat) : boolean;
 begin
   if teteje = 0 then
	           begin
	             writeln(#7'Stack underflow');
                     kivesz:=false;
	             exit;
	           end;
   adat:=stack[teteje];
   dec(teteje);
   writeln(adat:6, ' kivtele megtrtnt.');
   kivesz := true;
 end;

{ a fprogram }
var
   i        : integer;
   adatelem : tadat;

begin
  { a stack nullzsa }
  for i := 1  to  veremmeret do  stack[i] := 0;

  clrscr;
  { adatok bevitele a verembe }
  for i := 1 to 4 do
     betesz(i*i);

  writeln;
  { adatok kivtele a verembl}
  for i := 1 to  2 do
     kivesz(adatelem);

  writeln;
  { adatok bevitele a verembe }
  for i := 10 to 13 do
     betesz(i*i);

  writeln;
  { adatok kivtele a verembl}
  for i := 1 to  7 do
     kivesz(adatelem);

end.



