(* OOPFF.PAS *)

{---------------------------------------------------------------------
  Adott meghajtn, adott fjlmaszk alapjn fjlneveket keres program                           *
 ---------------------------------------------------------------------}

program OOPFF;
uses  OOPDir, Dos, Crt;

var
  DP: DirEntryPtr;
  Orig: PathStr;

{ A knyvtrstruktra feldolgozsa }
procedure ProcessDir(D: DirEntryPtr; DirName: PathStr);
  var
    DirPtr : DirEntryPtr;
  begin
  DirPtr := DirEntryPtr(D^.DirEntries.First);
  while DirPtr <> nil do
    begin
    if DirPtr^.IsDirectory then
      ProcessDir(DirPtr,DirName+'\'+DirPtr^.FileName)
      { az alknyvtrak rekurzv feldolgozsa }
    else
      WriteLn(DirName+'\'+DirPtr^.FileName);
    DirPtr := DirEntryPtr(D^.DirEntries.Next(DirPtr));
    end;
  end;

{ A fprogram }
begin
 clrscr;
 Orig := CurDir;
 WriteLn('OOPFF - fjlkeres program');
 writeln('--------------------------');
 if ParamCount <> 2 then { Hibs programindts }
   begin
   WriteLn;
   WriteLn('Hasznlat: OOPFF meghajt: file-spec.');
   WriteLn;
   WriteLn('Knyvtrnv nem adhat meg !');
   WriteLn;
   WriteLn('plda: OOPFF C: *.ZIP');
   WriteLn;
   Halt;
   end;

 ChDir(ParamStr(1));
 New(DP,Clear);

 WriteLn;
 Write('Keress a ',ParamStr(1),' meghajtn - ', ParamStr(2),' ...');
 DP^.FindDirectories(ParamStr(2),Archive);
 WriteLn;
 WriteLn;

 ProcessDir(DP,ParamStr(1));

 WriteLn;
 WriteLn('Vissza a kiindulsi alknyvtrba'#13#10'    ',Orig);
 ChDir(Orig);

 Dispose(DP,Done);
end.
