(* dirtree.pas *)
program dirtree;
uses crt, dos;

const ch : char = #32;

{ a fjlattribtumokat kir eljrs}
procedure writeattr(fn : string);
 const
   attrstr:string[6]='RHSVDA';
 var
   fp  : file;
   i   : integer;
   as  : string[7];
   attr: word;
 begin
   assign(fp,fn);
   getfattr(fp,attr);
   as:='[';
   for i:=1 to 6 do
     if (attr and (1 shl (i-1)))<>0 then as:=as+attrstr[i]
                                    else as:=as+'.';
   write(as,']');
 end;

{ a fjl ellenrzse a megadott knyvtrban }
procedure checkfile(fnev : string);
 var dirinfo: Searchrec;
 begin
   FindFirst(fnev, AnyFile, dirinfo);
   while DosError = 0 do
   begin
     if dirinfo.name[1]<>'.' then
        begin
           write('.....',dirinfo.Name);
           gotoxy(30,wherey); writeattr(dirinfo.name);
        end;
     writeln;
     FindNext(dirinfo);
   end;
 end;

{ a teljes knyvtrstruktra bejrsa rekurzv eljrssal }
procedure keres(dir,fnev:string);
 var
   dirinfo: SearchRec;
   s1:string;
 begin
   if keypressed then ch:=readkey;
   if ch=#27 then exit;

   getdir(0,s1);
   {$I-}
   chdir(dir);
   {$I+}
   if ioresult<>0 then
       begin
         writeln('Hibs knyvtr: ',dir);
         exit;
       end;
   writeln(dir);
   checkfile(fnev);
   FindFirst('*.*', Anyfile,dirinfo);
   while DosError = 0 do
   begin
     if dirinfo.name[1]<>'.' then
      begin
        {$I-}
        chdir(dirinfo.name);
        {$I+}
        if ioresult=0 then
           begin
             if dir[ord(dir[0])]='\' then dec(dir[0]);
             chdir('..');
             keres(dir+'\'+dirinfo.Name,fnev);
           end;

      end;
     FindNext(dirinfo);
   end;
  chdir(s1);
 end;

{ A fprogram }
begin
assign(output,'');
rewrite(output);
if paramcount<2 then
     begin
       writeln;
       writeln('Hasznlat: DIRTREE knyvtr fjlspec.');
       writeln;
       exit;
     end
     else
       keres(paramstr(1),paramstr(2));
end.

